/*
 * Functions treating input and output
 * of the data.
 *  by M.Hachimori, May 2000.
 */

#include "s_complex.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*
 * function to convert char into array of integer
 * ( delimiter is ' '.)
 */

int char_to_array(ch, ans)
  char *ch;
  short *ans;
{
  int j;
  char tmp;

  tmp = '\0';
  j = 0;
  ans[0] = 0;
  while(*ch < '0' || *ch > '9')
    {
    if (*ch == '#' || *ch == '\0')
      {
      *ans = -1;
      return 0;
      }
    ch ++;
    }
  while(1)
    {
    switch (*ch)
      {
      case '0': case '1': case '2': case '3':
      case '4': case '5': case '6': case '7':
      case '8': case '9':
        if (tmp == ' ') *(ans + ++ j) = 0;
        *(ans+j) *= 10;
        *(ans+j) += (*ch - '0');
        break;
      case ' ':
        break;
      default:
        *(ans + ++ j) = -1;
        return j;
      }
    tmp = *(ch ++);
    }
}

/*
 * function to convert array of integer into char
 */
void array_to_char(arr, s)
  short *arr;
  char s[];
{
  int n;

  while(1)
    {
    if (*arr == -1)
      break;
    n = *(arr ++);
    while(1)
      {
      *(s ++) = n % 10 + '0';
      if ((n /= 10) <= 0)
        break;
      }
    *(s ++) = ' ';
    }
  *s = '\0';
  return;
}

/*
 * function to input facet data from file
 */
Simplices *input_faces(filename)
  char filename[];
{
  FILE *datafile;
  int i, n, d, dim;
  char tmp[MAXLINE];
  short newface[MAXDIM + 2];
  Simplices *previous, *current, *return_address;


  if (strcmp(filename, "-") == 0) {
    datafile = stdin;
    }
  else {
    datafile = fopen(filename, "r");
    if (datafile == NULL){
      printf("no datafile!\n");
      exit (0);}
    }

  return_address = (Simplices*)malloc(sizeof(Simplices));
  current = return_address;
  current->next = NULL; current->prev = NULL;

  dim = -1; n = 0; previous = NULL;
  while (fgets(tmp, MAXLINE, datafile) != NULL)
    {
    d = char_to_array(tmp, newface);
    if (d == 0) continue;
    qsort(newface, d, sizeof(short), (void*)cmp);

    if (dim < d-1) dim = (d-1);
    current->prev = previous;
    current->vert[0] = d-1;
    for (i = 1; i <= d; i ++)
      current->vert[i] = newface[i-1];
    previous = current;
    current->next = (Simplices*)malloc(sizeof(Simplices));
    current = current->next;
    n ++;
    }
  free(previous->next);
  previous->next = NULL;

  fclose(datafile);
  return(return_address);

}


/*
 * function to compare 2 numbers
 */
int cmp(a, b)
  short *a;
  short *b;
{
  if (*a > *b) return 1;
  else if (*a < *b) return -1;
  return 0;
}


/*
 * function to print faces of a simplicial complex
 */
void print_faces(simplices)
  Simplices *simplices;
{
  int i;
  Simplices *current;

  current = simplices;
  while(current != NULL){
/*    printf("%d: ", current->vert[0]);*/
    for (i = 1; i <= current->vert[0] + 1; i ++)  /* current->vert[0] = dimension */
      printf("%d ", current->vert[i]);
    printf("\n");
    current = current->next;}

  return;
}

